function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function _toConsumableArray(arr) { return _arrayWithoutHoles(arr) || _iterableToArray(arr) || _nonIterableSpread(); }

function _nonIterableSpread() { throw new TypeError("Invalid attempt to spread non-iterable instance"); }

function _iterableToArray(iter) { if (Symbol.iterator in Object(iter) || Object.prototype.toString.call(iter) === "[object Arguments]") return Array.from(iter); }

function _arrayWithoutHoles(arr) { if (Array.isArray(arr)) { for (var i = 0, arr2 = new Array(arr.length); i < arr.length; i++) { arr2[i] = arr[i]; } return arr2; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); return Constructor; }

function _possibleConstructorReturn(self, call) { if (call && (_typeof(call) === "object" || typeof call === "function")) { return call; } return _assertThisInitialized(self); }

function _getPrototypeOf(o) { _getPrototypeOf = Object.setPrototypeOf ? Object.getPrototypeOf : function _getPrototypeOf(o) { return o.__proto__ || Object.getPrototypeOf(o); }; return _getPrototypeOf(o); }

function _assertThisInitialized(self) { if (self === void 0) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function"); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, writable: true, configurable: true } }); if (superClass) _setPrototypeOf(subClass, superClass); }

function _setPrototypeOf(o, p) { _setPrototypeOf = Object.setPrototypeOf || function _setPrototypeOf(o, p) { o.__proto__ = p; return o; }; return _setPrototypeOf(o, p); }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React from 'react';
import { Select, SelectVariant, CheckboxSelectGroup, CheckboxSelectOption } from '@patternfly/react-core';

var GroupedCheckboxSelectInput =
/*#__PURE__*/
function (_React$Component) {
  _inherits(GroupedCheckboxSelectInput, _React$Component);

  function GroupedCheckboxSelectInput() {
    var _getPrototypeOf2;

    var _this;

    _classCallCheck(this, GroupedCheckboxSelectInput);

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _possibleConstructorReturn(this, (_getPrototypeOf2 = _getPrototypeOf(GroupedCheckboxSelectInput)).call.apply(_getPrototypeOf2, [this].concat(args)));

    _defineProperty(_assertThisInitialized(_this), "state", {
      isExpanded: false,
      selected: []
    });

    _defineProperty(_assertThisInitialized(_this), "onToggle", function (isExpanded) {
      _this.setState({
        isExpanded: isExpanded
      });
    });

    _defineProperty(_assertThisInitialized(_this), "onSelect", function (event, selection) {
      var selected = _this.state.selected;

      if (selected.includes(selection)) {
        _this.setState(function (prevState) {
          return {
            selected: prevState.selected.filter(function (item) {
              return item !== selection;
            })
          };
        }, function () {
          return console.log('selections: ', _this.state.selected);
        });
      } else {
        _this.setState(function (prevState) {
          return {
            selected: [].concat(_toConsumableArray(prevState.selected), [selection])
          };
        }, function () {
          return console.log('selections: ', _this.state.selected);
        });
      }
    });

    _defineProperty(_assertThisInitialized(_this), "clearSelection", function () {
      _this.setState({
        selected: []
      });
    });

    _defineProperty(_assertThisInitialized(_this), "options", [React.createElement(CheckboxSelectGroup, {
      label: "Status",
      key: "group1"
    }, React.createElement(CheckboxSelectOption, {
      key: 0,
      value: "Running"
    }), React.createElement(CheckboxSelectOption, {
      key: 1,
      value: "Stopped"
    }), React.createElement(CheckboxSelectOption, {
      key: 2,
      value: "Down"
    }), React.createElement(CheckboxSelectOption, {
      key: 3,
      value: "Degraded"
    }), React.createElement(CheckboxSelectOption, {
      key: 4,
      value: "Needs Maintenence"
    })), React.createElement(CheckboxSelectGroup, {
      label: "Vendor Names",
      key: "group2"
    }, React.createElement(CheckboxSelectOption, {
      key: 5,
      value: "Dell"
    }), React.createElement(CheckboxSelectOption, {
      key: 6,
      value: "Samsung",
      isDisabled: true
    }), React.createElement(CheckboxSelectOption, {
      key: 7,
      value: "Hewlett-Packard"
    }))]);

    return _this;
  }

  _createClass(GroupedCheckboxSelectInput, [{
    key: "render",
    value: function render() {
      var _this$state = this.state,
          isExpanded = _this$state.isExpanded,
          selected = _this$state.selected;
      var titleId = 'grouped-checkbox-select-id';
      return React.createElement("div", null, React.createElement("span", {
        id: titleId,
        hidden: true
      }, "Grouped Checkbox Title"), React.createElement(Select, {
        variant: SelectVariant.checkbox,
        "aria-label": "Grouped Checkbox Select Input",
        onToggle: this.onToggle,
        onSelect: this.onSelect,
        selections: selected,
        isExpanded: isExpanded,
        placeholderText: "Filter by status",
        ariaLabelledBy: titleId,
        isGrouped: true
      }, this.options));
    }
  }]);

  return GroupedCheckboxSelectInput;
}(React.Component);

export default GroupedCheckboxSelectInput;